<template>
  <GManageTable
    :card="card"
    :level="level"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    :items="value"
    :get-new-item="getNewItem"
    :optional="optional"
    :wiki-entry="wikiEntry"
    @create="create"
    @edit="edit"
    @remove="remove"
    @deleteElement="$emit('delete')"
  >
    <template #form="{ item }">
      <v-row dense>
        <GCol cols="12">
          <GTextField
            v-model="item._attr.refType"
            i18n="dcc.common.attributes.refType"
            attr-ref-type
          />
        </GCol>
        <GCol cols="12" md="6">
          <XmlTextField
            v-model="item.reference"
            i18n="dcc.common.equipmentClassType.reference"
            validate="required notEmptyStringType"
          />
        </GCol>
        <GCol cols="12" md="6">
          <XmlTextField
            v-model="item.classID"
            i18n="dcc.common.equipmentClassType.classID"
            validate="required notEmptyStringType"
          />
        </GCol>
      </v-row>
    </template>
  </GManageTable>
</template>

<script>
import { EquipmentClassType } from "@d-ptb/dcc-js";
import { removeFromArray } from "assets/util/general";
import XmlTextField from "../../App/Form/XML/XmlTextField";
import { validatableMixin } from "../../Mixins/validatableMixin";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import GCol from "~/components/App/Common/GCol";
import GTextField from "~/components/App/Form/gTextField";

export default {
  name: "EquipmentClass",
  components: {
    GTextField,
    GCol,
    GManageTable,
    XmlTextField,
  },
  mixins: [validatableMixin],
  props: {
    value: Array,
    i18nBase: {
      type: String,
      default: "dcc.common.equipmentClassType",
    },
    card: {
      type: Boolean,
      default: true,
    },
    level: String,
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "equipmentClass",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.common.equipmentClassType.reference"),
          value: "reference._text",
        },
        {
          text: this.$t("dcc.common.equipmentClassType.classID"),
          value: "classID._text",
        },
      ],
    };
  },
  computed: {
    customRules() {
      return [() => this.value.length > 0];
    },
  },
  watch: {
    value() {
      this.validate();
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value, item);
    },
    getNewItem() {
      return new EquipmentClassType();
    },
    create(item) {
      this.value.push(new EquipmentClassType(item));
    },
    edit(item, index) {
      Object.assign(this.value[index], new EquipmentClassType(item));
    },
  },
};
</script>
